/**
 * File: Buttons.c
 * Author: Dylan Harootunian
 * Created January 8, 2021 12:20AM
 * ECE121 Winter 2021
 */
#include "Buttons.h"
#include <xc.h>
void button_init(void){
    //initalizes buttons (pins RD5-7 and RF1)
    TRISD = 0x00E0; //E0= 11100000 where RD5-7 are set to inputs
    TRISF = 0x0002; //2 = 10 where RF1 is set to an input
    
}

char button_get(void){
 //returns the current state of the button in the form of an unsigned char
 //this function will be used to turn on LEDs based on the button pushed
 //the butttons will set the char to a value corisponding to turning on two buttons
    char val = 0; //starting value for returned button value
    if(PORTFbits.RF1){ //BTN1
        val |= 0x03; // 3 in 8 bit binary is 00000011 so would trigger the first two LEDs
        //using an or equals allows multiple buttons to be pressed at once
    }
    if(PORTDbits.RD5){ //BTN2
        val |= 0x0C; // C in 8 bit binary is 00001100
    }
    if(PORTDbits.RD6){ //BTN3
        val |= 0x30; // 30 in 8 bit binary is 00110000
    }
    if(PORTDbits.RD7){ //BTN4
        val |= 0xC0; // C0 in 8 bit binary is 11000000
    }
    return val;
}