/**
 * File: FreeRunningTimer.c
 * Author: Dylan Harootunian
 * Created January 19, 2021 10:20PM
 * ECE121 Winter 2021
 */


#include "xc.h"
#include "sys/attribs.h"
#include "stdio.h"
#include "stdlib.h"
#include "BOARD.h"
#include "Protocol.h"
#include "stdint.h"
#include "MessageIDs.h"
#include "GenericTypeDefs.h"
#include "FreeRunningTimer.h"
static unsigned int mil = 0x00;
static unsigned int mic = 0x00;
#ifndef FRT
//int main(void)
//{
//    BOARD_Init();
//    Protocol_Init();
//    char testMessage[MAXPAYLOADLENGTH];
//    sprintf(testMessage, "Free Running Timer Compiled at %s %s", __DATE__, __TIME__);
//    Protocol_SendDebugMessage(testMessage);
//
//    FreeRunningTimer_Init();
//    unsigned int t = 1000;//1000ms is 1 second
//    unsigned int pingValue = 0xfff;
//    while (1) {
//        if(FreeRunningTimer_GetMilliSeconds()>=t){
//            LEDS_SET((!LEDS_GET()));//toggles led every second creating 0.5hz frequency
//            if(t%2000==0){//prints ms and us every 2 seconds
//                sprintf(testMessage, "Milliseconds: %d Microseconds: %d",mil, mic);
//                Protocol_SendDebugMessage(testMessage);
//            }
//            t+=1000;//increments wanted time
//        }
//        if (Protocol_IsMessageAvailable()) {
//            if (Protocol_ReadNextID() == ID_PING) {
//                
//                // send pong in response here
//                Protocol_GetPayload(&pingValue);
//                pingValue = Protocol_IntEndednessConversion(pingValue);
//                pingValue>>=1;
//                pingValue = Protocol_IntEndednessConversion(pingValue);
//                Protocol_SendMessage(4, ID_PONG, &pingValue);
//            }
//        }
//    }
//    while (1);
//}
#endif
void  __ISR(_TIMER_5_VECTOR , ipl3auto) Timer5IntHandler(void) {
    if(IFS0bits.T5IF){
        mil++;
        mic += 1000; 
    }
    IFS0bits.T5IF = 0;
    return;
}
void FreeRunningTimer_Init(void){
    T5CON= 0x0;//clearing registers
    T5CONbits.TCKPS = 0b011; //1:8 prescale
    TMR5 = 0x0;
    
    PR5 = BOARD_GetPBClock()/(8*1000); //5 is a micro so 5000 is a milliscond
    IFS0bits.T5IF = 0;
    IPC5bits.T5IP = 1;
    IEC0bits.T5IE = 1;
    T5CONbits.ON=1;
    return;
}
unsigned int FreeRunningTimer_GetMilliSeconds(void){
    return mil;
}
unsigned int FreeRunningTimer_GetMicroSeconds(void){
    return TMR5/5;
}
